#include <FreqPeriodCounter.h>
 
const byte counterPin = 3; 
const byte counterInterrupt = 1; // = pin 3
FreqPeriodCounter counter(counterPin, micros, 0);

unsigned long windspeed; 
 
void setup(void) 
{ 
  Serial.begin(115200); 
  attachInterrupt(counterInterrupt, counterISR, CHANGE);
}
 
void loop(void) 
{ 
  if(counter.ready()) { 
    windspeed = counter.hertz();    
    Serial.println(windspeed);
    if(windspeed > 200) windspeed = 0;
    Serial.print("Wind Speed: ");
    Serial.println(0.062*windspeed+0.578);
    delay(1000);  
  }
}
 
void counterISR()
{ 
  counter.poll();
}